<template>
  <div class="account-list">
    <h2 class="isActiveTopTab">{{isActiveTopTab}}</h2>
    <ob-table
      ref="table"
      :page-limit="50"
      is-css-selectable
      :remote-opt="getExecutorsOrder"
      :remote-trigger="$route"
      :update-timeout="isIrrelevant ? null : 10000"
      :columns="columns"
      :tableHeight="tableHeight"
      :functional-panel="true"
      @select="selectedOrder"
      id="account-table"
    >
      <div slot="notification" slot-scope="{data}">
        <notificationSlot :item="data.item"/>
      </div>
      <div slot="clock" slot-scope="{data}">
        <clockSlot :item="data.item"/>
      </div>
      <div slot="status" slot-scope="{data}">
        <div :class="[{'is-ready': data.item.currentState === 'NO_BIDS'}]" :data-uuid="data.item.uuid ? data.item.uuid : ''">
          <statusSlot :item="data.item"/>
        </div>
      </div>
      <div slot="price" slot-scope="{data}">
        <priceSlot :item="data.item"/>
      </div>
      <div slot="route" slot-scope="{data}">
        <routeSlot :item="data.item"/>
      </div>
      <div slot="signal" slot-scope="{data}">
        <signalSlot :item="data.item"/>
      </div>
      <div slot="requirements" slot-scope="{data}">
        <requirementsSlot :item="data.item"/>
      </div>
      <div slot="temp" slot-scope="{data}">
        <temp :item="data.item"/>
      </div>
      <div slot="type" slot-scope="{data}">
        <type :item="data.item"/>
      </div>
      <div slot="dateFrom" slot-scope="{data}">
        <dateFromSlot :item="data.item"/>
      </div>
      <div slot="owner" slot-scope="{data}">
        <ownerSlot :item="data.item"/>
      </div>
      <div slot="time" slot-scope="{data}">
        <timeSlot :item="data.item"/>
      </div>
      <template v-slot:extraFuncToPanel>
        <div class="account-tabs"
             :class="{'assigning': isActiveTopTab === 'assigning'}">
          <div
                  v-for="(tab, index) in tabs"
                  :key="index"
                  :class="[{'account-tabs__item-active': tab.id === activeTab }, {'account-tabs__item-disabled': tab.disabled}]"
                  class="account-tabs__item"
                  @click="setActive(tab.id)"
          >
            <template v-if="tab.icon">
              <i class="icon" :class="tab.icon"/>
            </template>
            <template v-else>
              <span :class="{'account-tabs__item-caution': notice(tab.id, noticeTab)}">{{tab.title}}</span>
            </template>
          </div>
        </div>
      </template>
    </ob-table>
  </div>
</template>

<script>

import ObTable from "common-components/src/obComponents/obTable"
import notificationSlot from './slots/notification'
import clockSlot from './slots/clocl'
import statusSlot from './slots/status'
import priceSlot from './slots/price'
import routeSlot from './slots/route'
import signalSlot from './slots/signalStatus'
import requirementsSlot from './slots/requirements'
import type from './slots/type'
import temp from './slots/temp'
import dateFromSlot from './slots/dateFrom'
import ownerSlot from './slots/owner'
import timeSlot from './slots/time'
import {mapGetters, mapActions, mapMutations} from 'vuex'

export default {
  components: {
    ObTable,
    notificationSlot,
    clockSlot,
    statusSlot,
    priceSlot,
    routeSlot,
    signalSlot,
    requirementsSlot,
    temp,
    type,
    dateFromSlot,
    ownerSlot,
    timeSlot
  },
  props: {
    columns: {
      type: Array,
      default: () => []
    }
  },
  data () {
    return {
      tableHeight: 0,
      showPanel: true,
      tabs: [
        {
          id: 'ALL',
          title: 'Все'
        },
        {
          id: 'ENDS',
          icon: 'clock'
        },
        {
          id: 'AUCTION',
          title: 'Аукционы'
        },
        {
          id: 'LOSING',
          title: 'Ставка перебита'
        },
        {
          id: 'BOOKING',
          title: 'Букинг-запросы'
        },
        {
          id: 'IRRELEVANT',
          title: 'Неактуальные'
        }
      ]
    }
  },
  mounted () {
    this.setLoadListMethod(this.$refs.table.loadData)
  },
  updated () {
    if (localStorage.getItem('uuid') && localStorage.getItem('uuid')!=='') {
      document.querySelector('[data-uuid="' + localStorage.getItem('uuid') + '"]')?.closest('tr').classList.add('row-selected')
    }
  },
  destroyed () {
    localStorage.setItem('uuid','')
  },
  computed: {
    ...mapGetters({
      tableLoader: 'account/tableLoader',
      orders: 'account/orders',
      order: 'account/order',
      activeTab: 'account/tab',
      noticeTab: 'account/noticeTab',
      filters: 'account/filters'
    }),
    arrTr () {
      return  document.getElementsByClassName('row-selected');
    },
    isActiveTopTab () {
      if(this.$route.name === 'requests__search-orders'){
        this.changeSearchType(this.$route.name);
        return 'search'
      }
      else if (this.$route.name ==='requests__assigning_resources'){
        this.changeSearchType(this.$route.name);
        return 'assigning'
      }
      else {
        return ''
      }
    },
    isIrrelevant () {
      return this.activeTab === 'IRRELEVANT'
    }
  },
  watch: {
    activeTab () {
      this.$refs.table.loadData({ init: true })
    }
  },
  methods: {
    ...mapActions('account', ['getOrder']),
    ...mapActions({
      getOrders: 'account/getOrders',
      setActive: 'account/activeTab',
      changeSearchType:'account/changeSearchType'
    }),
    ...mapMutations({
      turnLoaderTable: 'account/turnLoaderTable',
      turnLoaderRightPanel: 'account/loaderRightPanel',
      setListSignalLoader: 'account/setListSignalLoader',
      setLoaderFilter:'account/setLoaderFilter',
      setLoadListMethod:'account/setLoadListMethod',
      setOfferSuborderUuid:'account/setOfferSuborderUuid'
    }),
    loadData () {
      this.$refs.table.loadData({ init: true })
    },
    async getExecutorsOrder ({ page, size, query, sort }) {
      /**
       * 430px образуется за счет того, что
       * => 276px - это отсуп с самого вверха страницы и до низа хедера таблицы
       * => 124px - высота панели фильтров
       * => и 30px - отступ снизу между гницей снизу таблицы и до конца страницы
       **/

      const isAssignedResourcesRoute = this.$route.name === 'requests__assigning_resources'
      let carrierSearchType, searchStatus

      if (isAssignedResourcesRoute) {
        searchStatus = 'BOOKED'
        carrierSearchType = this.activeTab
      } else {
        const searchStatusMap = {
          ALL: 'ACTIVE',
          ENDS: 'TIMEOUT',
          AUCTION: 'ACTIVE',
          LOSING: 'LOOSING',
          BOOKING: 'ACTIVE',
          IRRELEVANT: 'IRRELEVANT',
        }

        const carrierSearchTypeMap = {
          ALL: 'ALL',
          ENDS: 'ALL',
          AUCTION: 'AUCTION',
          LOSING: 'AUCTION',
          BOOKING: 'BOOKING',
          IRRELEVANT: 'ALL',
        }

        carrierSearchType = carrierSearchTypeMap[this.activeTab]
        searchStatus = searchStatusMap[this.activeTab]
      }

      const data = await this.getOrders({ carrierSearchType, searchStatus, page, size, q: query, sort })

      this.tableHeight = window.innerHeight - 390

      this.setLoaderFilter(false)

      return data
    },
    notice (id, notice) {
      return notice.some(key => key === id)
    },
    selectedOrder (order) {
      this.turnLoaderRightPanel(true)
      this.setOfferSuborderUuid('targetSuborderUuid')
      this.getOrder(order)
      if (order.uuid) {
        localStorage.setItem('uuid', order.uuid)
        for (let i = 0; i <= this.arrTr.length; i++) {
          if (this.arrTr[i]?.querySelector('[data-uuid]').getAttribute('data-uuid') === localStorage.getItem('uuid')) {
            this.arrTr[i]?.classList.add('row-selected')
          } else {
            this.arrTr[i]?.classList.remove('row-selected')
          }
        }
      }
    },
    sizeTable () {
      this.showPanel = !this.showPanel;
    }
  }
}
</script>

<style lang="scss">
@import "~common-components/src/static/css/variables";
.isActiveTopTab{
  height: 0;
  opacity: 0;
}
.is-ready:before {
  content: '';
  width: 0;
  height: 0;
  position: absolute;
  left: 0;
  top: 0;
  border-style: solid;
  border-width: 16px 16px 0 0;
  border-color: $color-green-light transparent transparent transparent;
}
.account-list {
  td {
    position: relative;
  }
  &-loader {
    display: flex;
    justify-content: center;
    align-items: center;
    height: 300px;
  }
  &__route {
    width: 320px;
    display: flex;
    justify-content: space-between;
    font-size: 14px;

    &-dots {
      display: flex;
      justify-content: center;
      align-items: center;
      flex-grow: 12;
      position: relative;
      margin: 0 8px;
      &::after {
        position: absolute;
        content: '';
        top: 50%;
        width: 100%;
        height: 1px;
        border-top: 2px $color-blue-heavenly dotted;
      }

      &-count {
        background: $background-white;
        display: flex;
        justify-content: center;
        align-items: center;
        padding: 3px;
        height: 16px;
        font-size: 10px;
        line-height: 20px;
        letter-spacing: 1px;
        text-transform: uppercase;
        color: $light-denim;
        border: 1px solid $blue-blue-hoarfrost;
        box-sizing: border-box;
        border-radius: 5px;
      }

    }
  }
  &__type {
    display: none;
    @media screen and (min-width: 1920px){
      display: block;
    }
  }
  &__notification {
    width: 16px;
    height: 16px;
    border-bottom: solid 8px transparent;
    border-right: solid 8px transparent;
    border-left: solid 8px $caribbean;
    border-top: solid 8px $caribbean;
    position: absolute;
    top: 0;
    left: 0;
  }

  &__requirements {
    color: $topMenuTextHover;
  }
  &__clock {
    font-size: 22px;
  }
  &__owner {
    display: flex;
    justify-content: center;
    align-items: center;
    i {
      font-size: 20px;
      padding-right: 10px;
    }
  }
  &__status {
    font-size: 22px;
  }
  &__price {
    color: $color-text-base;
  }
  &__red {
    color: $light-raspberry-red
  }
  &__green {
    color: $caribbean;
  }
  &__blue {
    color: $cobalt;
  }
  &__grey {
    color: $gray-slate;
  }
  &__light-grey {
    color: $color-grey-span;
  }
}
</style>
<style lang="scss" scoped>
  .account-tabs {
    display: flex;
    width: 100%;
    &__item {
      display: flex;
      justify-content: center;
      align-self: center;
      height: 30px;
      font-size: 14px;
      line-height: 16px;
      color: $color-blue-navy-blue;
      padding: 7px 12px;
      border: 1px solid $color-grey-border;
      box-sizing: border-box;
      text-overflow: ellipsis;
      white-space: nowrap;
      overflow: hidden;
      cursor: pointer;
      span{
        margin-left: 0;
      }
      &:first-child{
        border-radius: 3px 0 0 3px;
      }
      &:nth-child(5){
        border-radius: 0 3px 3px 0;
      }
      &:last-child{
        border-radius: 3px;
        margin-left: 10px;
      }
      &-active {
        border: none;
        background: $blue-blue-hoarfrost;
        box-shadow: inset 0 4px 4px rgba(0, 75, 200, 0.3);
      }
      &-disabled {
        cursor: default;
        color: #A3A5AD;
        background: $color-white-lilac;
        pointer-events: none;
      }
      &-caution {
        position: relative;
        &:after {
          content: '';
          position: absolute;
          width: 6px;
          height: 6px;
          background: #10CF96;
          border-radius: 50%;
          margin-left: 2px;
        }
      }
      & > i.clock {
        font-size: 16px;
        font-weight: bold;
        &::before {
          color: $color-error;
        }
      }
    }
  }
  ::v-deep .ob-func-panel{
    &__controls{
      justify-content: flex-start;
      &-side{
        &:first-child{
          .ob-func-panel__control{
            &:nth-child(1){
              display: none;
            }
            &:nth-child(2){
              display: none;
            }
            &:nth-child(4){
              display: none;
            }
          }
        }
        &:last-child{
          width: 100%;
          .ob-func-panel__control{
            &:first-child{
              width: 100%;
            }
          }
        }
      }
    }
    .assigning{
      .account-tabs__item{
        &:nth-child(4), &:last-child{
          display: none;
        }
      }
    }
  }


  ::v-deep table{
    min-width: auto;
    border-collapse:inherit;
  }
  ::v-deep .table-panel-inner::-webkit-scrollbar {
    width: 6px;
    background: transparent;
    opacity: .3;
  }
  ::v-deep .table-panel-inner::-webkit-scrollbar-thumb {
    background: #b3d4e4;
    border-radius: 3px;
  }
  ::v-deep .table-panel-inner::-webkit-scrollbar-track {
    background: transparent;
  }

  ::v-deep .table-data th{
    &:nth-child(7){
      display: none;
      @media screen and (min-width:1920px){
        display: block;
      }
    }
  }
  ::v-deep .table-data td{
    &:nth-child(7){
      display: none;
      @media screen and (min-width:1920px){
        display: block;
      }
    }
  }
</style>
